'use strict';

var fs = require('fs');
var util = require('util');

const asyncReadFile = util.promisify(fs.readFile);

var readFileAsync = filePath => {
  return asyncReadFile(filePath, {
    encoding: 'utf8',
    flag: 'r',
  });
};

var parse = envStr => {
  const parsedObj = {};
  const envRegex = /^((.+?)[=](.*))$/gm;
  const commentRegex = /^[#].*?$/;

  let matchArr = [];

  while (matchArr !== null) {
    matchArr = envRegex.exec(envStr);

    if (matchArr && !commentRegex.test(matchArr[0])) {
      const key = matchArr[2].trim();
      const value = matchArr[3].trim().replace(/\\n/g, `\n`);
      parsedObj[key] = value;
    }
  }
  return parsedObj;
};

var index = async filePath => {
  const buffer = await readFileAsync(filePath);

  return parse(buffer);
};

module.exports = index;
